diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/startup.c
--- a/src/dep/startup.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/startup.c	Sun Oct 27 22:49:29 2013 -0700
@@ -697,74 +823,101 @@
 #endif
 			break;
 			
-		case 'd':
-			rtOpts->displayStats = TRUE;
-			break;
-		case 'D':
-			rtOpts->displayStats = TRUE;
-			rtOpts->csvStats = TRUE;
-			break;
-		case 'P':
-			rtOpts->displayPackets = TRUE;
-			break;
+    case 'd':
+      rtOpts->displayStats = TRUE;
+      break;
+    case 'D':
+      rtOpts->displayStats = TRUE;
+      rtOpts->verboseStats = TRUE;
+      rtOpts->csvStats = TRUE;
+      break;
+    case 'P':
+      rtOpts->displayPackets = TRUE;
+      break;
 
-		case 'R':
-			/* this option handling is now after the arguments processing (to show the help in case of -?) */
-			strncpy(rtOpts->recordFile, optarg, PATH_MAX);
-			rtOpts->do_record_quality_file = TRUE;
-			break;
+    case 'R':
+      /* this option handling is now after the arguments processing (to show the help in case of -?) */
+      strncpy(rtOpts->recordFile, optarg, PATH_MAX);
+      rtOpts->do_record_quality_file = TRUE;
+      break;
+    case 'X':
+      if(!strcasecmp(optarg, "nic"))
+      {
+        rtOpts->time_mode = TIME_NIC;
+      }
+      else if(!strcasecmp(optarg, "system"))
+      {
+        rtOpts->time_mode = TIME_SYSTEM;
+      }
+      else if(!strcasecmp(optarg, "both"))
+      {
+        rtOpts->time_mode = TIME_BOTH;
+      }
+      else if(!strcasecmp(optarg, "linux_hw"))
+      {
+        rtOpts->time_mode = TIME_SYSTEM_LINUX_HW;
+      }
+      else
+      {
+        ERROR("unsupported -z clock '%s'.\n", optarg);
+        *ret = 1;
+      }
+      /*
+      * Set a flag to control whether to indicate that we don't need
+      * to set the default time mode.
+      */
+      time_mode_specified = TRUE;
+      break;
+    case 'x':
+      rtOpts->noResetClock = TRUE;
+      break;
+    case 'O':
+      rtOpts->maxReset = atoi(optarg);
+      if (rtOpts->maxReset > 1000000000) {
+        ERROR("Use -x to prevent jumps of more"
+              " than one second.");
+        *ret = 1;
+        return (0);
+      }
+      break;
+    case 'M':
+    {
+      long double max_delay = strtod(optarg, NULL);
+      rtOpts->maxDelay.seconds = (Integer32)floor(max_delay);
+      rtOpts->maxDelay.nanoseconds =
+        (Integer32)round((max_delay - rtOpts->maxDelay.seconds) * 1000000000.0);
+      break;
+    }
+	break;
+    case 't':
+	rtOpts->noAdjust = TRUE;
+	break;
+    case 'a':
+      rtOpts->ap = strtol(optarg, &optarg, 0);
+      if (optarg[0])
+        rtOpts->ai = strtol(optarg + 1, 0, 0);
+      break;
+    case 'w':
+      rtOpts->s = strtol(optarg, &optarg, 0);
+      break;
+    case 'b':
+      memset(rtOpts->ifaceName, 0, IFACE_NAME_LENGTH);
+      strncpy(rtOpts->ifaceName, optarg, IFACE_NAME_LENGTH);
+      break;
 
+    case 'u':
+			rtOpts->do_unicast_mode = 1;
+      strncpy(rtOpts->unicastAddress, optarg,
+		      MAXHOSTNAMELEN);
 
-		case 'x':
-			rtOpts->noResetClock = TRUE;
-			break;
-		case 'O':
-			rtOpts->maxReset = atoi(optarg);
-			if (rtOpts->maxReset > 1000000000) {
-				ERROR("Use -x to prevent jumps of more"
-				       " than one second.");
-				*ret = 1;
-				return (0);
-			}
-			break;
-		case 'M':
-			rtOpts->maxDelay = atoi(optarg);
-			if (rtOpts->maxDelay > 1000000000) {
-				ERROR("Use -x to prevent jumps of more"
-				       " than one second.");
-				*ret = 1;
-				return (0);
-			}
-			break;
-		case 't':
-			rtOpts->noAdjust = TRUE;
-			break;
-		case 'a':
-			rtOpts->ap = strtol(optarg, &optarg, 0);
-			if (optarg[0])
-				rtOpts->ai = strtol(optarg + 1, 0, 0);
-			break;
-		case 'w':
-			rtOpts->s = strtol(optarg, &optarg, 0);
-			break;
-		case 'b':
-			memset(rtOpts->ifaceName, 0, IFACE_NAME_LENGTH);
-			strncpy(rtOpts->ifaceName, optarg, IFACE_NAME_LENGTH);
-			break;
+	/*
+	 * FIXME: some code still relies on checking if this variable is filled. Upgrade this to do_unicast_mode
+	 *
+	 * E.g.:  netSendEvent(Octet * buf, UInteger16 length, NetPath * netPath, Integer32 alt_dst)
+	 *  if(netPath->unicastAddr || alt_dst ) ...
+	 */
+      break;
 
-		case 'u':
-			rtOpts->do_unicast_mode = 1;
-			strncpy(rtOpts->unicastAddress, optarg, 
-				MAXHOSTNAMELEN);
-
-			/*
-			 * FIXME: some code still relies on checking if this variable is filled. Upgrade this to do_unicast_mode
-			 *
-			 * E.g.:  netSendEvent(Octet * buf, UInteger16 length, NetPath * netPath, Integer32 alt_dst)
-			 *  if(netPath->unicastAddr || alt_dst ){
-			 */
-			break;
-			 
 		case 'U':
 #ifdef PTP_EXPERIMENTAL
 			rtOpts->do_hybrid_mode = 1;
@@ -773,174 +926,244 @@
 #endif
 			break;
 
-			
-		case 'l':
-			rtOpts->inboundLatency.nanoseconds = 
-				strtol(optarg, &optarg, 0);
-			if (optarg[0])
-				rtOpts->outboundLatency.nanoseconds = 
-					strtol(optarg + 1, 0, 0);
-			break;
-		case 'o':
-			rtOpts->currentUtcOffset = strtol(optarg, &optarg, 0);
-			break;
-		case 'i':
-			rtOpts->domainNumber = strtol(optarg, &optarg, 0);
-			break;
 
-		case 'I':
+    case 'l':
+      rtOpts->inboundLatency.nanoseconds =
+	      strtol(optarg, &optarg, 0);
+      if (optarg[0])
+        rtOpts->outboundLatency.nanoseconds =
+		strtol(optarg + 1, 0, 0);
+      break;
+    case 'o':
+      rtOpts->currentUtcOffset = strtol(optarg, &optarg, 0);
+      rtOpts->currentUtcOffsetValid = TRUE;
+      break;
+    case 'i':
+      rtOpts->domainNumber = strtol(optarg, &optarg, 0);
+      if (rtOpts->domainNumber > 3) {
+	ERROR(" Please provide an integer between 0 to 3 with -i\n");
+	*ret = 1;
+	return (0);
+      }
+      break;
+
+	case 'I':
 #ifdef PTP_EXPERIMENTAL
-			rtOpts->mcast_group_Number = strtol(optarg, &optarg, 0);
+	rtOpts->mcast_group_Number = strtol(optarg, &optarg, 0);
+	if (rtOpts->mcast_group_Number > 3) {
+		ERROR(" Please provide an integer between 0 to 3 with -I\n");
+		*ret = 1;
+		return (0);
+      }
 #else
-			INFO("Multicast group selection not enabled. Please compile with PTP_EXPERIMENTAL\n");
+	INFO("Multicast group selection not enabled. Please compile with PTP_EXPERIMENTAL\n");
 #endif
-			break;
+	break;
+   
 
 
-			
-		case 'y':
-			rtOpts->syncInterval = strtol(optarg, 0, 0);
-			break;
-		case 'n':
-			rtOpts->announceInterval = strtol(optarg, 0, 0);
-			break;
+	case 'y':
+      rtOpts->syncInterval = strtod(optarg, 0);
+      break;
+    case 'n':
+      rtOpts->announceInterval = strtod(optarg, 0);
+      break;
 
 		case 'N':
 			rtOpts->announceReceiptTimeout = strtol(optarg, 0, 0);
 			break;
 			
-		case 'm':
-			rtOpts->max_foreign_records = strtol(optarg, 0, 0);
-			if (rtOpts->max_foreign_records < 1)
-				rtOpts->max_foreign_records = 1;
-			break;
-		case 'v':
-			rtOpts->clockQuality.offsetScaledLogVariance = 
-				strtol(optarg, 0, 0);
-			break;
-		case 'r':
-			rtOpts->clockQuality.clockAccuracy = 
-				strtol(optarg, 0, 0);
-			break;
-		case 's':
-			rtOpts->clockQuality.clockClass = strtol(optarg, 0, 0);
-			break;
-		case 'p':
-			rtOpts->priority1 = strtol(optarg, 0, 0);
-			break;
-		case 'q':
-			rtOpts->priority2 = strtol(optarg, 0, 0);
-			break;
-		case 'e':
-			rtOpts->ethernet_mode = TRUE;
-			ERROR("Not implemented yet !");
-			return 0;
-			break;
-		case 'h':
-			rtOpts->delayMechanism = E2E;
-			break;
+    case 'm':
+      rtOpts->max_foreign_records = strtol(optarg, 0, 0);
+      if (rtOpts->max_foreign_records < 1)
+        rtOpts->max_foreign_records = 1;
+      break;
+    case 'v':
+      rtOpts->clockQuality.offsetScaledLogVariance =
+        strtol(optarg, 0, 0);
+      break;
+    case 'r':
+      rtOpts->clockQuality.clockAccuracy =
+        strtol(optarg, 0, 0);
+      break;
+    case 's':
+      rtOpts->clockQuality.clockClass = strtol(optarg, 0, 0);
+      break;
+    case 'p':
+      rtOpts->priority1 = strtol(optarg, 0, 0);
+      break;
+    case 'q':
+      rtOpts->priority2 = strtol(optarg, 0, 0);
+      break;
+	case 'e':
+		rtOpts->ethernet_mode = TRUE;
+		ERROR("Not implemented yet !");
+		*ret = 3;
+		return 0;
+		break;
+	case 'h':
+		rtOpts->delayMechanism = E2E;
+		break;
 
-		case 'V':
-			rtOpts->log_seconds_between_message = strtol(optarg, &optarg, 0);
-			break;
+	case 'V':
+		rtOpts->log_seconds_between_message = strtol(optarg, &optarg, 0);
+		break;
 
-		case 'z':
-			rtOpts->delayMechanism = P2P;
-			break;
+	case 'Z':
+		rtOpts->ignore_delayreq_interval_master = TRUE;
+		break;
 
-		/* mode selection */
-		/* slave only */
-		case 'g':
-			mode_selected = 1;
-			rtOpts->slaveOnly = TRUE;
-			rtOpts->initial_delayreq = DEFAULT_DELAYREQ_INTERVAL;		// allow us to use faster rate at init
+	case 'z':
+		rtOpts->delayMechanism = P2P;
+		break;
 
-			/* we dont expect any parallel deamons, and we are strict about it  */
-			ntp_daemons_expected = 0;
-			ntp_daemons_strict = 1;
-			ptp_daemons_expected = 0;
-			ptp_daemons_strict = 1;
-			break;
-			
-		/* Master + NTP */
-		case 'G':
-			mode_selected = 2;
-			rtOpts->clockQuality.clockClass = DEFAULT_CLOCK_CLASS__APPLICATION_SPECIFIC_TIME_SOURCE;
-			rtOpts->slaveOnly = FALSE;
-			rtOpts->noAdjust = TRUE;
+    /* mode selection */
+    /* slave only */
+    case 'g':
+      switch (mode_selected) {
+	      case 2 :
+		      ERROR(" -G and -g cannot be specified together\n");
+		      *ret = 3;
+		      return 0;
+	      case 3:
+		      ERROR(" -W and -g cannot be specified together\n");
+		      *ret = 3;
+		      return 0;
+	      default:
+		      break;
+      }
+      mode_selected = 1;
+      rtOpts->slaveOnly = TRUE;
+      rtOpts->master_slave_mode = PTP_MODE_SLAVE;
+      rtOpts->initial_delayreq = DEFAULT_DELAYREQ_INTERVAL;		// allow us to use faster rate at init
 
-			/* we expect one ntpd daemon in parallel, but we are not strick about it */
-			ntp_daemons_expected = 1;
-			ntp_daemons_strict = 0;
-			ptp_daemons_expected = 0;
-			ptp_daemons_strict = 0;
-			break;
+      /* we dont expect any parallel deamons, and we are strict about it  */
+      ntp_daemons_expected = 0;
+      ntp_daemons_strict = 1;
+      ptp_daemons_expected = 0;
+      ptp_daemons_strict = 1;
 
-		/*
-		 *  master without NTP (Original Master behaviour):
-		 *    it falls back to slave mode when its inactive master;
-		 *    once it starts being active, it will drift for itself, so in actual terms it always requires NTP to work properly
-		 */
-		case 'W':
-			mode_selected = 3;
-			rtOpts->slaveOnly = FALSE;
-			rtOpts->noAdjust = FALSE;
+      default_time_mode = DEFAULT_SLAVE_TIME_MODE;
+      break;
 
-			/* we don't expect ntpd, but we can run with other ptpv1 deamons  */
-			ntp_daemons_expected = 0;
-			ntp_daemons_strict = 1;
-			ptp_daemons_expected = 0;
-			ptp_daemons_strict = 0;
-			break;
+    /* Master + NTP */
+    case 'G':
+      switch (mode_selected) {
+	      case 1 :
+		      ERROR(" -G and -g cannot be specified together\n");
+		      *ret = 3;
+		      return 0;
+	      case 3:
+		      ERROR(" -G and -W cannot be specified together\n");
+		      *ret = 3;
+		      return 0;
+	      default:
+		      break;
+      }
+      mode_selected = 2;
+      rtOpts->master_slave_mode = PTP_MODE_MASTER_WITH_NTP;
+      rtOpts->clockQuality.clockClass = DEFAULT_CLOCK_CLASS__APPLICATION_SPECIFIC_TIME_SOURCE;
+      rtOpts->slaveOnly = FALSE;
+      rtOpts->noAdjust = TRUE;
 
-			
-		case 'Y':
-			rtOpts->initial_delayreq = strtol(optarg, &optarg, 0);
-			rtOpts->subsequent_delayreq = rtOpts->initial_delayreq;
-			rtOpts->ignore_delayreq_interval_master = FALSE;
+      /* we expect one ntpd daemon in parallel, but we are not strick about it */
+      ntp_daemons_expected = 1;
+      ntp_daemons_strict = 0;
+      ptp_daemons_expected = 0;
+      ptp_daemons_strict = 0;
 
-			/* Use this to override the master-given DelayReq value */
-			if (optarg[0]){
-				rtOpts->subsequent_delayreq = strtol(optarg + 1, &optarg, 0);
-				rtOpts->ignore_delayreq_interval_master = TRUE;
-			}
-			break;
+      default_time_mode = DEFAULT_MASTER_TIME_MODE;
+      break;
 
-		case 'L':
-			/* enable running multiple ptpd2 daemons */
-			rtOpts->ignore_daemon_lock = TRUE;
-			break;
-		case 'j':
-			rtOpts->do_IGMP_refresh = FALSE;
-			break;
+    /*
+     *  master without NTP (Original Master behaviour):
+     *    it falls back to slave mode when its inactive master;
+     *    once it starts being active, it will drift for itself, so in actual terms it always requires NTP to work properly
+     */
+    case 'W':
+      switch (mode_selected) {
+	      case 1 :
+		      ERROR(" -W and -g cannot be specified together\n");
+		      *ret = 3;
+		      return 0;
+	      case 2:
+		      ERROR(" -G and -W cannot be specified together\n");
+		      *ret = 3;
+		      return 0;
+	      default:
+		      break;
+      }
+      rtOpts->master_slave_mode = PTP_MODE_MASTER_NO_NTP;
+      mode_selected = 3;
+      rtOpts->slaveOnly = FALSE;
+      rtOpts->noAdjust = FALSE;
+
+      /* we don't expect ntpd, but we can run with other ptpv1 deamons  */
+      ntp_daemons_expected = 0;
+      ntp_daemons_strict = 1;
+      ptp_daemons_expected = 0;
+      ptp_daemons_strict = 0;
+      default_time_mode = DEFAULT_MASTER_TIME_MODE;
+      break;
+
+      /* Use the NIC hardware; i.e. TIME_BOTH mode */
+    case 'K':
+/*
+#ifdef __sparc__
+	ERROR("HW assist (-K) is not supported on sparc\n");
+	*ret = 3;
+	return 0;
+#endif
+*/
+      use_hardware_assist = TRUE;
+      break;
+
 		
-			
+     case 'Y':
+	rtOpts->initial_delayreq = strtod(optarg, 0);
+	rtOpts->subsequent_delayreq = rtOpts->initial_delayreq;
+	rtOpts->ignore_delayreq_interval_master = FALSE;
 
-		default:
-			ERROR("Unknown parameter %c \n", c);
-			*ret = 1;
-			return 0;
-		}
+	/* Use this to override the master-given DelayReq value */
+	if (optarg[0]){
+		rtOpts->subsequent_delayreq = strtol(optarg + 1, &optarg, 0);
+		rtOpts->ignore_delayreq_interval_master = TRUE;
 	}
+      break;
 
+      case 'L':
+         /* enable running multiple ptpd2 daemons */
+	 rtOpts->ignore_daemon_lock = TRUE;
+	 break;
+      case 'j':
+	rtOpts->do_IGMP_refresh = FALSE;
+	break;
 
-	/*
-	 * we try to catch as many error conditions as possible, but before we call daemon().
-	 * the exception is the lock file, as we get a new pid when we call daemon(),
-	 * so this is checked twice: once to read, second to read/write
-	 */
-	if(geteuid() != 0)
-	{
-		display_short_help("Please run this daemon as root");
-			*ret = 1;
-			return 0;
-		}
+    default:
+      ERROR("Unknown parameter %c \n", c);
+      *ret = 1;
+      return 0;
+    }
+  }
 
-	if(!mode_selected){
-		display_short_help("Please select program mode");
-		*ret = 1;
-		return 0;
-	}
+
+  /*
+   * we try to catch as many error conditions as possible, but before we call daemon().
+   * the exception is the lock file, as we get a new pid when we call daemon(),
+   * so this is checked twice: once to read, second to read/write
+   */
+  if(geteuid() != 0)
+  {
+    display_short_help("Please run this daemon as root", TRUE);
+      *ret = 1;
+      return 0;
+  }
+
+  if(rtOpts->master_slave_mode == PTP_MODE_NULL) {
+    display_short_help("Please select program mode", TRUE);
+    *ret = 1;
+    return 0;
+  }
 
 #ifdef PTP_EXPERIMENTAL
 	if(rtOpts->do_unicast_mode && rtOpts->do_hybrid_mode){
@@ -950,42 +1173,47 @@
 	}
 #endif
 
+    /* If the time mode has not been specified then use the default time mode */
+    if (time_mode_specified == FALSE) {
+      if (use_hardware_assist) {
+	      default_time_mode = TIME_BOTH;
+      }
+      rtOpts->time_mode = default_time_mode;
+    }
 
+  ptpClock = (PtpClock *) calloc(1, sizeof(PtpClock));
+  if (!ptpClock) {
+    PERROR("failed to allocate memory for protocol engine data");
+    *ret = 2;
+    return 0;
+  } else {
+    DBG("allocated %d bytes for protocol engine data\n",
+        (int)sizeof(PtpClock));
+    ptpClock->foreign = (ForeignMasterRecord *)
+      calloc(rtOpts->max_foreign_records,
+            sizeof(ForeignMasterRecord));
+    if (!ptpClock->foreign) {
+      PERROR("failed to allocate memory for foreign "
+            "master data");
+      *ret = 2;
+      free(ptpClock);
+      return 0;
+    } else {
+      DBG("allocated %d bytes for foreign master data\n",
+          (int)(rtOpts->max_foreign_records *
+          sizeof(ForeignMasterRecord)));
+    }
+  }
 
+  /* Init to 0 net buffer */
+  memset(ptpClock->msgIbuf, 0, PACKET_SIZE);
+  memset(ptpClock->msgObuf, 0, PACKET_SIZE);
 
+  /* Initialise sockets to invalid */
+  ptpClock->netPath.eventSock = -1;
+  ptpClock->netPath.generalSock = -1;
 
 
-
-	ptpClock = (PtpClock *) calloc(1, sizeof(PtpClock));
-	if (!ptpClock) {
-		PERROR("failed to allocate memory for protocol engine data");
-		*ret = 2;
-		return 0;
-	} else {
-		DBG("allocated %d bytes for protocol engine data\n", 
-		    (int)sizeof(PtpClock));
-		ptpClock->foreign = (ForeignMasterRecord *)
-			calloc(rtOpts->max_foreign_records, 
-			       sizeof(ForeignMasterRecord));
-		if (!ptpClock->foreign) {
-			PERROR("failed to allocate memory for foreign "
-			       "master data");
-			*ret = 2;
-			free(ptpClock);
-			return 0;
-		} else {
-			DBG("allocated %d bytes for foreign master data\n", 
-			    (int)(rtOpts->max_foreign_records * 
-				  sizeof(ForeignMasterRecord)));
-		}
-	}
-
-	/* Init to 0 net buffer */
-	memset(ptpClock->msgIbuf, 0, PACKET_SIZE);
-	memset(ptpClock->msgObuf, 0, PACKET_SIZE);
-
-
- 
 	/*
 	 * This section discusses some of the complexities of doing proper Locking and Background Daemon programs.
 	 *
@@ -997,7 +1225,7 @@
 	 *
 	 *      The correct way is to lock the shared resource that needs write protection: the kernel clock itself.
 	 *   (http://mywiki.wooledge.org/ProcessManagement#How_do_I_make_sure_only_one_copy_of_my_script_can_run_at_a_time.3F)
-	 *   Thus, ptpd2 will lock the file /var/run/kernel_clock in daemon_already_running().
+	 *   Thus, ptpd2 will lock the file LOCKFILE in daemon_already_running().
 	 *      Unfortunately this is not followed by the other discipliners, so on top of locking we also try to find
 	 *   them by name (we spawn pgrep in check_parallel_daemons()).
 	 *      Another alternative would be to clone NTP's way of doing this: to bind to port 123, the NTP port. Although this
@@ -1024,10 +1252,13 @@
 	if(rtOpts->ignore_daemon_lock == 0){
 		/* check and create Lock */
 		if(daemon_already_running()){
-			ERROR("  Error:   Multiple ptpd2 instances detected (-L to ignore lock file %s)\n", LOCKFILE);
+			ERROR("  Error:   Multiple ptpd instances detected (-L to ignore lock file %s)\n", LOCKFILE);
 			*ret = 3;
+			free(ptpClock);
 			return 0;
 		}
+		/* unlock the file so that child process can lock it */
+		(void) unlockfile(global_lock_fd);
 	} else {
 		/* if we ignore the daemon lock, we also are not strict for parallel daemons (but we always syslog what is happening) */
 		ptp_daemons_strict=0;
@@ -1035,86 +1266,92 @@
 	}
 
 
-	if(check_parallel_daemons("ptpd", ptp_daemons_expected, ptp_daemons_strict, rtOpts) &&
-	   check_parallel_daemons("ntpd", ntp_daemons_expected, ntp_daemons_strict, rtOpts))
-	{
-		/* ok */
-	} else {
-		*ret = 3;
-		return 0;
-	}
+  if(check_parallel_daemons("ptpd", ptp_daemons_expected, ptp_daemons_strict, rtOpts) &&
+    check_parallel_daemons("ntpd", ntp_daemons_expected, ntp_daemons_strict, rtOpts))
+  {
+    /* ok */
+  } else {
+    *ret = 3;
+    free(ptpClock);
+    return 0;
+  }
 
 
+  /* Manage open files: stats and quality file */
+  if(rtOpts->do_record_quality_file){
+	if (recordToFile(rtOpts))
+      noclose = 1;
+    else
+      PERROR("could not open quality file");
+  }
 
+  if(rtOpts->do_log_to_file){
+		if(logToFile(rtOpts))
+      noclose = 1;
+    else
+      PERROR("could not open output file");
 
+    rtOpts->displayStats = TRUE;
+    rtOpts->verboseStats = TRUE;
+    rtOpts->csvStats = TRUE;
+  }
 
-	/* Manage open files: stats and quality file */
-	if(rtOpts->do_record_quality_file){
-		if (recordToFile(rtOpts))
-			noclose = 1;
-		else
-			PERROR("could not open quality file");
-	}
 
-	if(rtOpts->do_log_to_file){
-		if(logToFile(rtOpts))
-			noclose = 1;
-		else
-			PERROR("could not open output file");
 
-		rtOpts->displayStats = TRUE;
-		rtOpts->csvStats = TRUE;
-	}
-
-
-
-	/*  DAEMON */
+  /*  DAEMON */
 #ifdef PTPD_NO_DAEMON
-	if(rtOpts->nonDaemon == 0){
-		rtOpts->nonDaemon= 1;
-	}
+  if(rtOpts->nonDaemon == 0){
+    rtOpts->nonDaemon= 1;
+  }
 #endif
 
 
-	
-	if(rtOpts->nonDaemon == 0){
-		/* fork to daemon */
-		if (daemon(0, noclose) == -1) {
-			PERROR("failed to start as daemon");
-			*ret = 3;
-			return 0;
-		}
+
+  if(rtOpts->nonDaemon == 0){
+    /* fork to daemon */
+    if (daemon(0, noclose) == -1) {
+      PERROR("failed to start as daemon");
+      *ret = 3;
+      free(ptpClock);
+      return 0;
+    }
 		INFO("  Info:    Now running as a daemon\n");
-	}
+  }
 
 	/* if syslog is on, send all messages to syslog only  */
 	rtOpts->syslog_startup_messages_also_to_stdout = FALSE;   
 
 
-	/* Second lock check, to replace the contents with our own new PID. It seems that F_WRLCK is not inherited to the child, so we lock again */
-	if(rtOpts->ignore_daemon_lock == 0){
-		/* check and create Lock */
-		if(daemon_already_running()){
+  /* Second lock check, to replace the contents with our own new PID. It seems that F_WRLCK is not inherited to the child, so we lock again */
+  if(rtOpts->ignore_daemon_lock == 0){
+    /* check and create Lock */
+    if(daemon_already_running()){
 			ERROR("Multiple instances of this daemon detected (Use option -L to ignore lock file %s)\n", LOCKFILE);
-			*ret = 3;
-			return 0;
-		}
-	}
+      *ret = 3;
+      free(ptpClock);
+      return 0;
+    }
+  }
 
-	
-	/* use new synchronous signal handlers */
-	signal(SIGINT,  catch_signals);
-	signal(SIGTERM, catch_signals);
-	signal(SIGHUP,  catch_signals);
 
-	signal(SIGUSR1, catch_signals);
-	signal(SIGUSR2, catch_signals);
+  /* use new syncronous signal handlers */
+  signal(SIGINT,  catch_signals);
+  signal(SIGTERM, catch_signals);
+  signal(SIGHUP,  catch_signals);
 
-	*ret = 0;
+  signal(SIGUSR1, catch_signals);
+  signal(SIGUSR2, catch_signals);
+
+#ifdef DBG_SIGRTMIN_LEAP_SECOND
+  signal(SIGRTMIN,   catch_signals);
+  signal(SIGRTMIN+1, catch_signals);
+#endif
+
+  *ret = 0;
 
 	INFO("  Info:    Startup finished sucessfully\n");
 
-	return ptpClock;
+  return ptpClock;
 }
 
 
